import * as types from '../datatypes.js';
import * as error from '../error.js';
import { DataExpr } from './expr.js';
/**
 * Capture lexically scoped variables and store them into a new closure object
 * Leaves address of the closure object on the stack
 */
export class ClosureCreateExpr extends DataExpr {
    macro;
    /**
     * Lexically scoped variables to be captured
     */
    captured;
    constructor(token, macro) {
        if (!(macro.datatype instanceof types.ArrowType))
            throw new error.SyntaxError('invalid runtime closure', [token, macro.token]);
        super(token, macro.datatype);
        this.macro = macro;
    }
    out(ctx, fun) {
        // Create new function for it's body
        // Add function to module table
        // Capture lexically scoped vars and convert them to args/lm addr?
        // this is super painful ... maybe check to see if they've been compiled yet?
        // maybe extend expressions?
        return '';
    }
    children() {
        throw new Error('todo');
    }
}
export class ClosureInvokeExpr extends DataExpr {
    out(ctx, fun) {
        // Load function index from closure object pointer
        // Put closure object pointer back onto stack
        // Invoke function in via function table
        return '';
    }
    children() {
        throw new Error('todo');
    }
}
//# sourceMappingURL=closure.js.map